Bug 74441 - [Win Accessibility] Don't expose 0 as the value for each empty cell in Calc
Summary: [Win Accessibility] Don't expose 0 as the value for each empty cell in Calc
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
4.2.0.4 release
Hardware: All Windows (All)
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:4.4.0 target:4.3.4
Keywords:
Depends on:
Blocks: a11y-Windows
  Show dependency treegraph
 
Reported: 2014-02-03 13:47 UTC by Marco Zehe
Modified: 2014-11-07 12:39 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Marco Zehe 2014-02-03 13:47:38 UTC
STR:
1. Turn on IAccessible2 support and run LibreOffice with NVDA.
2. Create a new Spreadsheet document.
3. Navigate around using the arrow keys.

Expected: Cells should be announced with their coordinates, and "blank" or something similar should be spoken to indicate the cell is empty.
Actual: The cell coordinates are announced, but the value is then spoken as "0". This would give the indication that there is a value of 0 in each cell, even though visually the cells definitely do not contain zeroes.

This should be changed so that there is a clear indication whether there is a 0 in a cell or the cell is blank. 0 could be the result of a calculation!
Comment 1 V Stuart Foote 2014-02-03 15:53:56 UTC
Confirming behavior on Windows builds

Version: 4.2.0.4
Build ID: 05dceb5d363845f2cf968344d7adab8dcfb2ba71

Version: 4.3.0.0.alpha0+
Build ID: 4bb7e9a1b0dd2f72609affde0170c0a2d4fff44b
TinderBox: Win-x86@42, Branch:master, Time: 2014-02-02_01:08:10

It picks up the '0' from its MSAA accValue, for the correctly assigned IAccessible2 role tableCell. So that default assignment probably needs to be adjusted from '0' to "empty"?  Anyone up on what ODF 1.2 calls for in .ods formatting?

The other aspect of this is what would get assigned for that value with tableCells in Writer. Seems we are not there yet.

Looking at it, at present a table inserted there gets assigned an IAccessible2 role of 'paragraph', with MSAA accRole of clientArea but is also assigned the same accValue of '0', rather than "empty".  So, unless there is a major structural issue with ODF .odt for writer that would need to be changed on both counts as well.
Comment 2 Niklas Johansson 2014-10-16 08:12:11 UTC
Should Calc really present "blank" or "empty" as the accValue? Wouldn't it make more sence to return an empty string and possibly let the screen reader take care of presenting it as empty?
Comment 3 V Stuart Foote 2014-10-21 00:35:07 UTC
Marco, Niklas, *,

Bug 84854 is disrupting QA of 32-bit builds, but working as best as possible with 32-bit builds on Windows, I think you are getting close with this.

Still have an issue in gaining focus to the Calc tablecells, but once focused the blank tablecells are no longer sounding a "zero".

Version: 4.4.0.0.alpha1+
Build ID: ae218f4895082ea9fca8f414a332bcf47045ba8c
TinderBox: Win-x86@39, Branch:master, Time: 2014-10-20_15:19:52
Comment 4 V Stuart Foote 2014-11-03 00:50:45 UTC
resolved fixed with http://cgit.freedesktop.org/libreoffice/core/commit/?id=55eca9dbb34aec8c435da91c0748453e3e097f1e

Caolán, Niklas could we back port to 4.3 for the 4.3.4 build?
Comment 5 Commit Notification 2014-11-07 11:44:03 UTC
Niklas Johansson committed a patch related to this issue.
It has been pushed to "libreoffice-4-3":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=a148f119c7f6fe758f9bf8905ac12c646d934a52&h=libreoffice-4-3

fdo#74441 [Accessiblity] Don't expose 0 for empty cells in Calc

It will be available in 4.3.3.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 6 V Stuart Foote 2014-11-07 12:39:22 UTC
setting target to 4.3.4